﻿<#
 This script will take info from BridgePhone SQLite DB and displays it correctly.

 Created by Kalev Tiirmaa 11.05.2017
 #
 #ANDMEBAASID:
#   GAMESET - mängude tulemused
#   MEMBERSET - inimeste info
#   MOVEMENT - liikumised
#   PAIRS - paaride info
#>

function Avak2igu_kaart ($Avakäik)
 {
  switch ($Avakäik)
   {
51 {return '<font color="green">&clubs;</font>2'}
50 {return '<font color="green">&clubs;</font>3'}
49 {return '<font color="green">&clubs;</font>4'}
48 {return '<font color="green">&clubs;</font>5'}
47 {return '<font color="green">&clubs;</font>6'}
46 {return '<font color="green">&clubs;</font>7'}
45 {return '<font color="green">&clubs;</font>8'}
44 {return '<font color="green">&clubs;</font>9'}
43 {return '<font color="green">&clubs;</font>10'}
42 {return '<font color="green">&clubs;</font>S'}
41 {return '<font color="green">&clubs;</font>E'}
40 {return '<font color="green">&clubs;</font>K'}
39 {return '<font color="green">&clubs;</font>Ä'}
38 {return '<font color="brown">&diams;</font>2'}
37 {return '<font color="brown">&diams;</font>3'}
36 {return '<font color="brown">&diams;</font>4'}
35 {return '<font color="brown">&diams;</font>5'}
34 {return '<font color="brown">&diams;</font>6'}
33 {return '<font color="brown">&diams;</font>7'}
32 {return '<font color="brown">&diams;</font>8'}
31 {return '<font color="brown">&diams;</font>9'}
30 {return '<font color="brown">&diams;</font>10'}
29 {return '<font color="brown">&diams;</font>S'}
28 {return '<font color="brown">&diams;</font>E'}
27 {return '<font color="brown">&diams;</font>K'}
26 {return '<font color="brown">&diams;</font>Ä'}
25 {return '<font color="red">&hearts;</font>2'}
24 {return '<font color="red">&hearts;</font>3'}
23 {return '<font color="red">&hearts;</font>4'}
22 {return '<font color="red">&hearts;</font>5'}
21 {return '<font color="red">&hearts;</font>6'}
20 {return '<font color="red">&hearts;</font>7'}
19 {return '<font color="red">&hearts;</font>8'}
18 {return '<font color="red">&hearts;</font>9'}
17 {return '<font color="red">&hearts;</font>10'}
16 {return '<font color="red">&hearts;</font>S'}
15 {return '<font color="red">&hearts;</font>E'}
14 {return '<font color="red">&hearts;</font>K'}
13 {return '<font color="red">&hearts;</font>Ä'}
12 {return '<font color="blue">&spades;</font>2'}
11 {return '<font color="blue">&spades;</font>3'}
10 {return '<font color="blue">&spades;</font>4'}
9 {return '<font color="blue">&spades;</font>5'}
8 {return '<font color="blue">&spades;</font>6'}
7 {return '<font color="blue">&spades;</font>7'}
6 {return '<font color="blue">&spades;</font>8'}
5 {return '<font color="blue">&spades;</font>9'}
4 {return '<font color="blue">&spades;</font>10'}
3 {return '<font color="blue">&spades;</font>S'}
2 {return '<font color="blue">&spades;</font>E'}
1 {return '<font color="blue">&spades;</font>K'}
0 {return '<font color="blue">&spades;</font>Ä'}
default {return "-"}
   }
 }

 function Mis_kaart ($Kaart)
  {
   switch ($Kaart)
    {
     {($_ % 13) -eq 1} {return "A"}
     {($_ % 13) -eq 2} {return "K"}
     {($_ % 13) -eq 3} {return "E"}
     {($_ % 13) -eq 4} {return "S"}
     {($_ % 13) -eq 5} {return "10"}
     {($_ % 13) -eq 6} {return "9"}
     {($_ % 13) -eq 7} {return "8"}
     {($_ % 13) -eq 8} {return "7"}
     {($_ % 13) -eq 9} {return "6"}
     {($_ % 13) -eq 10} {return "5"}
     {($_ % 13) -eq 11} {return "4"}
     {($_ % 13) -eq 12} {return "3"}
     {($_ % 13) -eq 0} {return "2"}
    }
  }

function Table-Query($Table_Name,$DB_connection)
 {
  #Creating a Query
  #$Table_Name = "pairs"
  $sql = $DB_connection.CreateCommand()
  $sql.CommandText = "SELECT * FROM $Table_Name"
  $adapter = New-Object -TypeName System.Data.SQLite.SQLiteDataAdapter $sql
  $data = New-Object System.Data.DataSet
  [void]$adapter.Fill($data)
  return $data.Tables
  $sql.Dispose()
 }

function Mast-HTMLiks($Mastid)
{
  switch ($Mastid)
   {
     0 {return ('<font color="green">&clubs;</font>')}
     1 {return ('<font color="brown">&diams;</font>')}
     2 {return ('<font color="red">&hearts;</font>')}
     3 {return ('<font color="blue">&spades;</font>')}
     4 {return ("NT")}
   }
}

function KOntra-HTMLiks($kontrad)
 {
  switch ($kontrad)
    {
     default {return ("")}
     1 {return ('<font color="red">X</font>')}
     2 {return ('<font color="blue">XX</font>')}
    }
 }

#region Base data
#$DB_asukoht = "E:\Kalev\GoogleDrive\Bridge\KeilaBK\20170510"
$DB_asukoht = "E:\Bridge"
$DB_nimi = "BP20170726181204.db"
$kuupaev_failinimesse =$DB_nimi.Substring(2,4)+ $DB_nimi.Substring(6,2) + $DB_nimi.Substring(8,2)
if (Test-Path -Path "$DB_asukoht\BPScTmp" -ErrorAction SilentlyContinue)
 {New-Item -Path $DB_asukoht -Name "BPScTmp" -ItemType Directory -Force |Out-Null}
$BPScTempFolder = "$DB_asukoht\BPScTmp"

Add-Type -Path "C:\Program Files\System.Data.SQLite\2015\bin\System.Data.SQLite.dll"
$con = New-Object -TypeName System.Data.SQLite.SQLiteConnection
$con.ConnectionString = "Data Source=$DB_asukoht\$DB_nimi"
$con.Open()
$people = Table-Query -Table_Name memberset -DB_connection $con
$pairs = Table-Query -Table_Name pairs -DB_connection $con
$games = Table-Query -Table_Name gameset -DB_connection $con
$movements = Table-Query -Table_Name movement -DB_connection $con
$jaotused = Table-Query -Table_Name distributions -DB_connection $con
$con.Close()

class Tulemus
{
    # Optionally, add attributes to prevent invalid values
    [ValidateNotNullOrEmpty()][int]$T_jaotus
    [ValidateNotNullOrEmpty()][int]$T_mitu
    [ValidateNotNullOrEmpty()][int]$T_skoor
}
#endregion

#region Andmefailide tekitamine
$Liikmedfail = "BPSc_Liikmed.csv"
if (test-path -Path "$BPScTempFolder\$Liikmedfail")
 {Remove-Item -Path "$BPScTempFolder\$Liikmedfail" -Force}
New-Item -Path $BPScTempFolder -Name $Liikmedfail -ItemType File -Force |Out-Null
Add-Content -Path "$BPScTempFolder\$Liikmedfail" -Value "Eesnimi;Perenimi;Kasutajanimi" -Encoding UTF8

foreach ($gamer in $people)
 {
  $FirstName = (Get-Culture).textinfo.totitlecase(($gamer.first_name).tolower())
  $LastName = (Get-Culture).textinfo.totitlecase(($gamer.surname).tolower())
  if ($LastName -eq "Vaartnou")
   {$LastName = "Väärtnõu"}
  if ($LastName -eq "Ryndal")
   {$LastName = "Ründal"}
  if ($LastName -eq "Joonsaar")
   {$FirstName = "Jüri"}
  if ($gamer.short_name -eq "vahkt")
   {
    $FirstName = "Tõnno"
    $LastName = "Vähk"
   }
  if ($gamer.short_name -eq "vahkj")
   {$LastName = "Vähk"}
  if ($gamer.short_name -eq "Jyrman")
   {$LastName = "Jürman"}

     $UserName = $gamer.short_name
  Add-Content -Path "$BPScTempFolder\$Liikmedfail" -Value ("$FirstName;$LastName;$UserName") -Encoding UTF8
 }

# SIIN ON FAIL BPSc_paarid

$Paaridefail = "BPSc_paarid.csv"
if (test-path -Path "$BPScTempFolder\$Paaridefail")
 {Remove-Item -Path "$BPScTempFolder\$Paaridefail" -Force}
New-Item -Path $BPScTempFolder -Name $Paaridefail -ItemType File -Force |Out-Null
Add-Content -Path "$BPScTempFolder\$Paaridefail" -Value "Nr;Nimed" -Encoding UTF8

$T_Liikmed = Import-Csv -Path "$BPScTempFolder\$Liikmedfail" -Delimiter ";" -Encoding UTF8
$Paaride_koefitsent=0
foreach ($pair in $pairs)
 {
  if ($pair.deleted -eq -1 -and ($pair.player_name1).Length -gt 0)
   {
    $Mitmes = $pair.pair_number
    $FirstMember = $T_Liikmed | Where-Object {$_.Kasutajanimi -eq $pair.player_name1} |Select-Object -ExpandProperty Perenimi
    $SecondMember =  $T_Liikmed | Where-Object {$_.Kasutajanimi -eq $pair.player_name2} |Select-Object -ExpandProperty Perenimi
    Add-Content -Path "$BPScTempFolder\$Paaridefail" -Value ("$Mitmes;$FirstMember & $SecondMember") -Encoding UTF8
    if ($FirstMember -eq "Tyhi")
     {
      $Paaride_koefitsent=1
      $Tyhipaar = $Mitmes
     }
   }
 }

$MAX_paare = 0
$MAX_laudu = 0
$MAX_voore = 0
$MAX_jaotuseid = 0
$MAX_ID= 0
$Jaotuseid_voorus = 100
foreach ($liikumine in $movements)
 {
  if ($liikumine.TableNR -gt $MAX_laudu)
   {$MAX_laudu = $liikumine.TableNR}
  if ($liikumine.Round -gt $MAX_voore)
   {$MAX_voore = $liikumine.Round}
  if ($liikumine.HighBoard -gt $MAX_jaotuseid)
   {$MAX_jaotuseid = $liikumine.HighBoard}
  if ($liikumine.NSPair -gt $MAX_paare)
   {$MAX_paare = $liikumine.NSPair}
  if ($liikumine._id -gt $MAX_ID)
   {$MAX_ID = $liikumine._id}
  if ($liikumine.HighBoard -lt $Jaotuseid_voorus)
   {$Jaotuseid_voorus = $liikumine.HighBoard}
 }
$MAX_punkte = ($MAX_paare/2 - 1 -$Paaride_koefitsent)*2


# SIIN ON FAIL T_fail

$T_fail = "T_fail.csv"
if (test-path -Path "$BPScTempFolder\$T_fail")
 {Remove-Item -Path "$BPScTempFolder\$T_fail" -Force}
New-Item -Path $BPScTempFolder -Name $T_fail -ItemType File -Force |Out-Null
Add-Content -Path "$BPScTempFolder\$T_fail" -Value "Jaotus;Skoor;Mitu;MP"
$TpJ = New-Object -TypeName Tulemus
for ($i=1;$i -le $MAX_jaotuseid;$i++)
 {
  #$i = 1
  $M2ngitud = $games | Where-Object {$_.board_number -eq $i -and $_.deleted -eq 0} | Sort-Object @{e={$_.score -as [int]}} -Descending
  $k = 0
  $TpJ.T_jaotus = $null
  $TpJ.T_mitu = $null
  $TpJ.T_skoor = $null
  $MPsid = $MAX_punkte - ($MAX_paare/2 - $M2ngitud.Count)*2
  #$M2ngitud.Count
  foreach ($M2ng in $M2ngitud)
   {
    if ($M2ng.pair_NS -ne $Tyhipaar)
     {
      if ($k -eq 0)
       {
        $T_jaotus =$M2ng.board_number
        $T_skoor=$M2ng.score
        $T_mitu=1
        $T_MPsid = $MPsid
       }
      else
       {
        if ($M2ng.score -eq $T_skoor)
         {
          $T_mitu++
          $T_MPsid--
         }
        else
         {
          Add-Content -Path "$BPScTempFolder\$T_fail" -Value ([string]$T_jaotus + ";" + [string]$T_skoor + ";" + $T_mitu.ToString() + ";" + $T_MPsid.tostring())
          $T_jaotus=$M2ng.board_number
          $T_skoor=$M2ng.score
          $T_mitu=1
          $T_MPsid = $MPsid - (2 * $k)
         }
       }
       $k++
     }
   }
   Add-Content -Path "$BPScTempFolder\$T_fail" -Value ([string]$T_jaotus + ";" + [string]$T_skoor + ";" + $T_mitu.ToString() + ";" + $T_MPsid.tostring())
}

# SIIN ON FAIL BPSc_tulemused

$Tulemused = "BPSc_tulemused.csv"
if (test-path -Path "$BPScTempFolder\$Tulemused")
 {Remove-Item -Path "$BPScTempFolder\$Tulemused" -Force}
New-Item -Path $BPScTempFolder -Name $Tulemused -ItemType File -Force |Out-Null
Add-Content -Path "$BPScTempFolder\$Tulemused" -Value "Laud;Voor;Jaotus;Paar;NSvOW;Mangija;Korgus;Mast;Kontra;Tulemus;Skoor;Avakaik;MP;protsent;MAX;Vastane"
$T_info = Import-Csv -Path "$BPScTempFolder\$T_fail" -Delimiter ";" -Encoding UTF8
for ($i = 1; $i -le $MAX_jaotuseid; $i++)
{ 
 #$i=20
 $m2ngud = $games | Where-Object {$_.board_number -eq $i -and $_.deleted -eq 0} | Sort-Object -Property score -Descending
 $MAX_punkte_per_board = $MAX_punkte - ($MAX_paare/2 - $M2ngud.Count)*2
foreach ($mang in $m2ngud)
 {
   if ($mang.pair_NS -ne $Tyhipaar)
    { 
    $Laud = $mang.table_number
    $Voor = $mang.round_number
    $Jaotus = $i
    $Paar = $mang.pair_NS
    Switch ($mang.direction)
         {
          1 {$M2ngija = "N"}
          2 {$M2ngija = "E"}
          3 {$M2ngija = "S"}
          4 {$M2ngija = "W"}
         }
    $K6rgus = $mang.nr_tricks
    $Mast = $mang.suit
    $kontra = $mang.doubled
    $Tulemus = $mang.result
    $Skoor = $mang.score
    $Avak2ik = $mang.lead_card
    $punkte = $T_info | Where-Object {$_.Jaotus -eq $i -and $_.Skoor -eq $mang.score} |Select-Object -ExpandProperty MP
    $Protsent = $punkte/$MAX_punkte_per_board
    if ($punkte -eq $MAX_punkte_per_board)
     {$MAX = 1}
     else
      {$MAX = 0}
    $Vastane = $mang.pair_EW
    $Rida = "$Laud;$Voor;$i;$Paar;NS;$M2ngija;$K6rgus;$Mast;$kontra;$Tulemus;$Skoor;$Avak2ik;$punkte;$Protsent;$MAX;$Vastane"
    Add-Content -Path "$BPScTempFolder\$Tulemused" -Value $Rida
    
    $Paar = $mang.pair_EW
    $Vastane = $mang.pair_NS
    $punkte = $MAX_punkte_per_board - $punkte
    if ($punkte -eq $MAX_punkte_per_board)
     {$MAX = 1}
     else
      {$MAX = 0}
    $Protsent = 1 - $Protsent
    $Rida = "$Laud;$Voor;$i;$Paar;EW;$M2ngija;$K6rgus;$Mast;$kontra;$Tulemus;$Skoor;$Avak2ik;$punkte;$Protsent;$MAX;$Vastane"
    Add-Content -Path "$BPScTempFolder\$Tulemused" -Value $Rida
  }
 }
}
 #endregion

#region MPs to pair
$Lopptulemus = "BPSc_Lopptulemus.csv"
if (test-path -Path "$BPScTempFolder\$Lopptulemus")
 {Remove-Item -Path "$BPScTempFolder\$Lopptulemus" -Force}
New-Item -Path $BPScTempFolder -Name $Lopptulemus -ItemType File -Force |Out-Null
Add-Content -Path "$BPScTempFolder\$Lopptulemus" -Value "Paari Nr;Nimed;MP;Protsent;MAXe;Mänge" -Encoding UTF8
$T_Tulemused = Import-Csv -Path "$BPScTempFolder\$Tulemused" -Delimiter ";" -Encoding UTF8
$T_paarid = Import-Csv -Path "$BPScTempFolder\$Paaridefail" -Delimiter ";" -Encoding UTF8
$Palju_m2nge_m2ngitud = 0
for ($i=1;$i -le $MAX_paare;$i++)
 {
  $K_MAXe = [int]0
  $K_Mpsid = 0
  $K_M2nge = 0
  $K_Protsent = 0
  for ($j=1;$j -le $MAX_jaotuseid;$j++)
   {
    if ($T_Tulemused |Where-Object {$_.Jaotus -eq $j -and $_.Paar -eq $i})
     {
      $skoor = $T_Tulemused |Where-Object {$_.Jaotus -eq $j -and $_.Paar -eq $i} | Select-Object -ExpandProperty Skoor
      if ($skoor -ne $null)
       {
        $J_tulemus = $T_Tulemused |Where-Object {$_.Jaotus -eq $j -and $_.Paar -eq $i} |Select-Object -ExpandProperty MP
        $J_protsent = $T_Tulemused |Where-Object {$_.Jaotus -eq $j -and $_.Paar -eq $i} |Select-Object -ExpandProperty protsent
        $J_MAX = $T_Tulemused |Where-Object {$_.Jaotus -eq $j -and $_.Paar -eq $i} |Select-Object -ExpandProperty MAX
        $K_Mpsid = $K_Mpsid + [int]$J_tulemus
        $K_Protsent = $K_Protsent + $J_protsent
        $K_MAXe = $K_MAXe + [int]$J_MAX
        $K_M2nge++
        $vaheinfo = $T_Tulemused |Where-Object {$_.Paar -eq $i -and $_.jaotus -eq $j}
       }
      else
       {$Palju_m2nge_m2ngitud++}
     }
   }
   $Palju_m2nge_m2ngitud = $Palju_m2nge_m2ngitud + $K_M2nge
  if ($K_M2nge -eq 0 -or $K_M2nge -eq $null)
   {$Protsent = 0}
   else
    {
     $Protsent ="{0:P2}" -f ($K_Protsent/$K_M2nge)
     
     $paar = $T_paarid | Where-Object {$_.Nr -eq $i} |Select-Object -ExpandProperty Nimed
     $Yxik_failinimi = ("KBK_$kuupaev_failinimesse" + "_$paar.html").Replace(" ","")
     $paar_lingiga = '<a href="./' + $Yxik_failinimi + '">' + $Paar + "</a>"
     Add-Content -Path "$BPScTempFolder\$Lopptulemus" -Value "$i;$paar_lingiga;$K_Mpsid;$Protsent;$K_MAXe;$K_M2nge" -Encoding UTF8
    }
 }
 $BPSc_ViimneMP = Import-Csv -Path "$BPScTempFolder\$Lopptulemus" -Delimiter ";" -Encoding UTF8
 $BPSc_ViimneMP = $BPSc_ViimneMP | Sort-Object -Property Protsent -Descending
 #@{e={$_.Protsent -as [decimal]}} -Descending
 $koht = 1
 $Lopptulemus1 = "BPSc_Lopptulemus_1.csv"
 if (test-path -Path "$BPScTempFolder\$Lopptulemus1")
  {Remove-Item -Path "$BPScTempFolder\$Lopptulemus1" -Force}
 New-Item -Path $BPScTempFolder -Name $Lopptulemus1 -ItemType File -Force |Out-Null
 Add-Content -Path "$BPScTempFolder\$Lopptulemus1" -Value "Koht;Paari nr;Nimed;MP;Protsent;MAXe;Mänge" -Encoding UTF8
 foreach ($L_tulemus in $BPSc_ViimneMP)
 {
   $Rida=($koht.ToString() + ";" + $L_tulemus.'Paari nr' + ";" + $L_tulemus.Nimed + ";" + $L_tulemus.MP + ";" + $L_tulemus.Protsent + ";" + $L_tulemus.MAXe + ";" + $L_tulemus.Mänge)
     Add-Content -Path "$BPScTempFolder\$Lopptulemus1" -Value $Rida -Encoding UTF8
     $koht ++
 }
$BPSc_ViimneMP = Import-Csv -Path "$BPScTempFolder\$Lopptulemus1" -Delimiter ";" -Encoding UTF8
#endregion

#region Kokku tulemuse HTMLi tegemine ja avamine
$a = '<META HTTP-EQUIV="refresh" CONTENT="10">'
$a = $a + "<style>"
$a = $a + "BODY{background-color:peachpuff;}"
$a = $a + "TABLE{border-width: 1px;border-style: solid;border-color: black;border-collapse: collapse;}"
$a = $a + "TH{border-width: 2px;padding: 5px;border-style: solid;border-color: black;background-color:thistle}"
$a = $a + "TD{border-width: 2px;padding: 5px;border-style: solid;border-color: black;background-color:PaleGoldenrod}"
$a = $a + "</style>"
$a = $a + "<script>function goBack() { window.history.back()}</script>"
$kuupaev = $DB_nimi.Substring(8,2) + "." + $DB_nimi.Substring(6,2) + "." + $DB_nimi.Substring(2,4)
 
$Yldarvestuse_fail = "$DB_asukoht\KBK_$kuupaev_failinimesse" + "_yldarvestus.html"
 $Jaotused_file = "KBK_$kuupaev_failinimesse" + "_jaotused.html"
$BPSc_ViimneMP | Select-Object Koht, "Paari Nr", Nimed, MP, Protsent, MAXe, Mänge | 
ConvertTo-HTML -head $a -body ("<H2>Keila bridžiklubi paariturniir $kuupaev</H2>" +  '<br><button onclick="goBack()">Mine tagasi</button> <br><a href="./' + $Jaotused_file + '">Kõik jaotused</a>') | 
Out-File "$Yldarvestuse_fail" -Force

 (Get-Content $Yldarvestuse_fail).Replace('&lt;', '<') |Set-Content $Yldarvestuse_fail
 (Get-Content $Yldarvestuse_fail).Replace('&quot;', '"') |Set-Content $Yldarvestuse_fail
 (Get-Content $Yldarvestuse_fail).Replace('&gt;', '>') |Set-Content $Yldarvestuse_fail
 (Get-Content $Yldarvestuse_fail).Replace('&amp;', '&') |Set-Content $Yldarvestuse_fail
 (Get-Content $Yldarvestuse_fail).Replace('ä', '&auml;') |Set-Content $Yldarvestuse_fail
 (Get-Content $Yldarvestuse_fail).Replace('õ', '&otilde;') |Set-Content $Yldarvestuse_fail
 (Get-Content $Yldarvestuse_fail).Replace('ž', '&#382;') |Set-Content $Yldarvestuse_fail

if (-not (test-path -Path "$BPScTempFolder\Kord_k2ivitatud.txt" -ErrorAction SilentlyContinue))
 {
  Invoke-Expression $Yldarvestuse_fail
  new-item -Path $BPScTempFolder -Name "Kord_k2ivitatud.txt" -ItemType File -Force |Out-Null
 }
#endregion

#region iga jaotuse kohta eraldi tulemused
if ($Paaride_koefitsent -eq 1)
  {$H_m2ngitud = ($Palju_m2nge_m2ngitud + $MAX_jaotuseid)/2}
 else
  {$H_m2ngitud = $Palju_m2nge_m2ngitud/2}
#if ($H_m2ngitud -eq ($MAX_ID * $Jaotuseid_voorus))
# {
  $K6ik_jaotused_file = "$DB_asukoht\KBK_$kuupaev_failinimesse" + "_jaotused.html"
  #siia tulevad arvutused, kui kõik mängud on mängitud
  $a = ''
  $a = $a + "<style>"
  $a = $a + "BODY{background-color:peachpuff;}"
  $a = $a + "TABLE{border-width: 1px;border-style: solid;border-color: black;border-collapse: collapse;}"
  $a = $a + "TH{border-width: 2px;padding: 5px;border-style: solid;border-color: black;background-color:thistle}"
  $a = $a + "TD{border-width: 2px;padding: 5px;border-style: solid;border-color: black;background-color:PaleGoldenrod}"
  $a = $a + "</style>"
  $a = $a + "<script>function goBack() { window.history.back()}</script>"

  $Per_jaotus = Import-Csv -Path "$BPScTempFolder\$Tulemused" -Delimiter ";" -Encoding UTF8
  $Per_jaotus = $Per_jaotus |Sort-Object -Property Paar
  $Body = "<H1>Keila bridžiklubi paariturniir $kuupaev </H1>" + '<br><button onclick="goBack()">Mine tagasi</button>'
  for ($i=1;$i -le $MAX_jaotuseid;$i++)
   {
    $x_jaotaja = $i % 4
    switch ($x_jaotaja)
     {
      1 {$jaotaja = "N"}
      2 {$jaotaja = "E"}
      3 {$jaotaja = "S"}
      0 {$jaotaja = "W"}
     }
     $x_tsoonsus = $i % 16
     switch ($x_tsoonsus)
      {
       1 {$tsoonsus = "-"}
       2 {$tsoonsus = "NS"}
       3 {$tsoonsus = "EW"}
       4 {$tsoonsus = "Kõik"}
       5 {$tsoonsus = "NS"}
       6 {$tsoonsus = "EW"}
       7 {$tsoonsus = "Kõik"}
       8 {$tsoonsus = "-"}
       9 {$tsoonsus = "EW"}
       10 {$tsoonsus = "Kõik"}
       11 {$tsoonsus = "-"}
       12 {$tsoonsus = "NS"}
       13 {$tsoonsus = "Kõik"}
       14 {$tsoonsus = "-"}
       15 {$tsoonsus = "NS"}
       0 {$tsoonsus = "EW"}
      }
    $BPSc_Jaod_kokku = "BPSc_jaod_kokku_$i.csv"
    if (test-path -Path "$BPScTempFolder\$BPSc_Jaod_kokku")
     {Remove-Item -Path "$BPScTempFolder\$BPSc_Jaod_kokku" -Force}
    New-Item -Path $BPScTempFolder -Name $BPSc_Jaod_kokku -ItemType File -Force |Out-Null
    Add-Content -Path "$BPScTempFolder\$BPSc_Jaod_kokku" -Value "Paari nr|Nimed|Liin|Vastane|Leping|Mängija|Avakäik|Tihisid|Skoor|MP" -Encoding UTF8
    #$i=5
    $jaotuse_lehed = $jaotused | Where-Object {$_.board_number -eq $i} |Select-Object -ExpandProperty distribution
    $Vastava_jaotuse_lehed = ""
    if ($jaotuse_lehed -ne $null)
    {
    $Vastava_jaotuse_lehed = "<!-- Begin Hand --><table style='width: 350px' frame='border' cellpadding='10' width='400' style='font-size:120%' > <!-- row 1 --> <tr><!-- (1,1): dealer, vulnerability -->"
     $Vastava_jaotuse_lehed = $Vastava_jaotuse_lehed + "<td> </td> <!-- (1,2): North hand --><td> <i>"
    for ($m=1;$m -le 4;$m++)
     {
      switch ($m)
       {
        1 {$n=1}
        2 {$n=4}
        3 {$n=2}
        4 {$n=3}
       }
      if ($n -eq 1)
        {$Vastava_jaotuse_lehed = $Vastava_jaotuse_lehed +  "North</i> <br/> <font style='color:blue;font-weight:bold'>&spades; "}
      if ($n -eq 2)
        {$Vastava_jaotuse_lehed = $Vastava_jaotuse_lehed +  "<!-- (2,2) empty --> <td> </td> <!-- (2,3): east hand --> <td> <i>East</i> <br/> <font style='color:blue;font-weight:bold'>&spades; "}
      if ($n -eq 3)
        {$Vastava_jaotuse_lehed = $Vastava_jaotuse_lehed +  "</tr> <!-- row 3 --> <tr> <!-- (3,1): empty --> <td> </td> <!-- (3,2) south hand --> <td> <i>South</i> <br/> <font style='color:blue;font-weight:bold'>&spades; "}
      if ($n -eq 4)
        {$Vastava_jaotuse_lehed = $Vastava_jaotuse_lehed +  " <td> </td> </tr> <!-- row 2 -->  <tr>  <!-- (2,1): west hand --> <td> <i>West</i> <br/> <font style='color:blue;font-weight:bold'>&spades; "}
      
      #Write-Output ("$k / " +  $vastav_kaart)
     for ($k=1;$k -le 52;$k++)
       {
        $vastav_kaart = $jaotuse_lehed.Substring($k*2-1,1)
        if ($vastav_kaart -eq $n)
         {$Vastava_jaotuse_lehed = $Vastava_jaotuse_lehed + (Mis_kaart -Kaart $k)}
        if ($k -eq 13)
         {$Vastava_jaotuse_lehed = $Vastava_jaotuse_lehed +  "</font> <br/> <font style='color:red;font-weight:bold'>&hearts; "}
        if ($k -eq 26)
         {$Vastava_jaotuse_lehed = $Vastava_jaotuse_lehed + "</font> <br/> <font style='color:brown;font-weight:bold'>&diams; "}
        if ($k -eq 39)
         {$Vastava_jaotuse_lehed = $Vastava_jaotuse_lehed + "</font> <br/> <font style='color:green;font-weight:bold'>&clubs; "}
       }
       $Vastava_jaotuse_lehed = $Vastava_jaotuse_lehed + "</font> </td>"
     }
     $Vastava_jaotuse_lehed = $Vastava_jaotuse_lehed +  "<!-- (3,3) empty --> <td> </td> </tr> <!-- row 4: Bidding in center of table --> </table><!-- End Hand -->"    
   }
    foreach ($Per_jagu in $Per_jaotus)
     {
      if ($Per_jagu.Jaotus -eq $i)
       {
        $Mast = Mast-HTMLiks -Mastid $Per_jagu.Mast
        $kontra = KOntra-HTMLiks -kontrad $Per_jagu.Kontra
        $V_mangija = $Per_jagu.Mangija
        #Switch ($Per_jagu.Valjamangija)
        # {
        #  1 {$V_mangija = "N"}
        #  2 {$V_mangija = "E"}
        #  3 {$V_mangija = "S"}
        #  4 {$V_mangija = "W"}
        # }
        $skoor = $Per_jagu.Skoor
        if ($Per_jagu.NSvOW -eq "EW")
         {$skoor = 0 - $skoor}
         $Tihisid = [int]$Per_jagu.Korgus + 6 + [int]$Per_jagu.Tulemus
        $Nimed = $BPSc_ViimneMP |Where-Object {$_.'Paari Nr' -eq $Per_jagu.Paar}|Select-Object -ExpandProperty Nimed
        $rida = "<center>" + [string]$Per_jagu.Paar + "|" + $Nimed + "|<center>" + [string]$Per_jagu.NSvOW + "|<center>-" + [string]$Per_jagu.Vastane + "-|<center>" + [string]$Per_jagu.Korgus + $Mast + " " + $Kontra + "|<center>" + $V_mangija  + "|<center>" + [string](Avak2igu_kaart -Avakäik $Per_jagu.Avakaik) + "|<center>" + [string]$Tihisid + '</center>|<div align="right">' + $skoor + "</div>|<center>" + [string]$Per_jagu.MP + "</center>"
        Add-Content -Path "$BPScTempFolder\$BPSc_Jaod_kokku" -Value $Rida -Encoding UTF8
       }
     }
     $Jtsd_kokku = Import-Csv -Path "$BPScTempFolder\$BPSc_Jaod_kokku" -Delimiter "|" -Encoding UTF8
     $Body+="<H2>Jagu $i</H2>Jaotaja: <b>$jaotaja</b> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Tsoonis: <b> $tsoonsus</b><br/> " + $Vastava_jaotuse_lehed
     $body+= $Jtsd_kokku | 
      Select "Paari Nr", Nimed, Liin, Vastane, Leping, "Mängija", "Avakäik", Tihisid, Skoor, MP |
      Convertto-Html -Fragment -As Table
   }
  ConvertTo-HTML -Body $body -Title "Keila bridžiklubi paariturniir $kuupaev" -PostContent "<h6>$(Get-Date)</h6>" -Head $a|
 Out-File $K6ik_jaotused_file -Encoding utf8
 (Get-Content $K6ik_jaotused_file).Replace('&lt;', '<') |Set-Content $K6ik_jaotused_file
 (Get-Content $K6ik_jaotused_file).Replace('&quot;', '"') |Set-Content $K6ik_jaotused_file
 (Get-Content $K6ik_jaotused_file).Replace('&gt;', '>') |Set-Content $K6ik_jaotused_file
 (Get-Content $K6ik_jaotused_file).Replace('&amp;', '&') |Set-Content $K6ik_jaotused_file
 (Get-Content $K6ik_jaotused_file).Replace('ä', '&auml;') |Set-Content $K6ik_jaotused_file
 (Get-Content $K6ik_jaotused_file).Replace('õ', '&otilde;') |Set-Content $K6ik_jaotused_file
  (Get-Content $K6ik_jaotused_file).Replace('ž', '&#382;') |Set-Content $K6ik_jaotused_file
# }
#endregion

#region Tulemused per Paar
$Per_paar = $Per_jaotus |Sort-Object @{e={$_.jaotus -as [int]}}
$Per_paar = $Per_paar |Sort-Object @{e={$_.voor -as [int]}}
$head = ''
$head = $head + "<style>"
$head = $head + "table, th, td {border: 1px solid black;border-collapse: collapse;}"
$head = $head + "th, td {padding: 5px; text-align: left;}"
$head = $head + "</style>"
for ($i = 1; $i -le $MAX_paare; $i++)
{ 
 
 #$i=1
 $Paari_nimi = $T_paarid | Where-Object {$_.Nr -eq $i} |Select-Object -ExpandProperty Nimed
 $failinimi = ("KBK_$kuupaev_failinimesse" + "_$Paari_nimi.html").Replace(" ","")
 $a = '<table style="width:100%"><tbody><tr><td><h3>Kuupäev</h3></td><td colspan="2"><h3>' + $kuupaev
 $a = $a + '</h3><tr><td><h3>Paar</h3></td><td><h3>' + $i.tostring() + '</h3></td><td><h3>' + $Paari_nimi + '</h3></td></tr></tbody></table>'+"`n"
 for ($v = 1;$v -le $MAX_voore;$v++)
  {
   #$v=1
   $info = $Per_paar|Where-Object {$_.Voor -eq $v -and $_.paar -eq $i} |Sort-Object -Property Jaotus
   $Laud = ($movements |Where-Object {$_.Round -eq $v -and ($_.NSPair -eq $i -or $_.EWPair -eq $i)}).TableNr
   $LowBoard = ($movements |Where-Object {$_.Round -eq $v -and ($_.NSPair -eq $i -or $_.EWPair -eq $i)}).LowBoard
   $HighBoard = ($movements |Where-Object {$_.Round -eq $v -and ($_.NSPair -eq $i -or $_.EWPair -eq $i)}).HighBoard
   $NS  = ($movements |Where-Object {$_.Round -eq $v -and ($_.NSPair -eq $i -or $_.EWPair -eq $i)}).NSPair
   $EW  = ($movements |Where-Object {$_.Round -eq $v -and ($_.NSPair -eq $i -or $_.EWPair -eq $i)}).EWPair
   if ($NS -eq $i)
    {
     $Liin = "NS"
     $Vastane = $EW
    }
    else
     {
      $Liin = "EW"
      $Vastane = $NS
     }
    $Vastaste_nimed = $BPSc_ViimneMP |Where-Object {$_.'Paari Nr' -eq $Vastane}|Select-Object -ExpandProperty Nimed
    $Vastaste_MPd = $BPSc_ViimneMP |Where-Object {$_.'Paari Nr' -eq $Vastane}|Select-Object -ExpandProperty MP
    $Vastaste_protsent = $BPSc_ViimneMP |Where-Object {$_.'Paari Nr' -eq $Vastane}|Select-Object -ExpandProperty Protsent
   $a = $a + '<table style="width:100%"><tbody><tr><td colspan="2"><h2>Voor ' + "$v</h2></td>"
   $a = $a + "<td>Laud <b>$Laud</b></td>"
   $a = $a + '<td colspan="2">Jaotused <b>' + "$LowBoard - $HighBoard</b></td></tr>"
   $a = $a + '<tr><td colspan="2"><b>' + "$Liin</b> vastu paarile <b>$Vastane</b></td>"
   $a = $a + '<td colspan="2"><b>' + "$Vastaste_nimed</b></td>"
   $a = $a + "<td><b>($Vastaste_MPd = $Vastaste_protsent)</b></td></tr>"
   $Voor_MP = 0
   $Voor_protsent = 0
   foreach ($kild in $info)
    {
     $Voor_MP = $Voor_MP + $kild.MP
     $Voor_protsent = $Voor_protsent + $kild.Protsent
     $a = $a + "<tr><td>Jaotus <b>" + [string]$kild.Jaotus + "</b></td>"
     $a = $a + "<td><b>" + [string]$kild.NSvOW + "</b></td>"
     if ($kild.Tulemus -eq 0)
      {$Paari_tulemus = "="}
      else
       {$Paari_tulemus = [string]$kild.Tulemus}
     $a = $a + "<td><b>" + [string]$kild.korgus +" " + (Mast-HTMLiks -Mastid $kild.Mast) + " " + (Kontra-HTMLiks -Kontrad $kild.Kontra) + " $Paari_tulemus</b></td>"
     $a = $a + "<td><b>" + [String]$kild.Skoor + "</b></td>"
     $a = $a + "<td><b>" + [string]$kild.MP + " = " + ("{0:P2}" -f [double]$kild.Protsent) + "</b></td></tr>"
    }
    $Voor_protsent = $Voor_protsent/$info.Count
    $a = $a + '<tr><td colspan="4">Jaod kokku selles voorus</td>'
    $a = $a + "<td><b>$Voor_MP = " + ("{0:P2}" -f $Voor_protsent) + "</b></td</tr></tbody></table><br>"
  }
 
ConvertTo-HTML -Body $a -Title "Keila bridžiklubi paariturniir $kuupaev" -PostContent "<h6>$(Get-Date)</h6>" -Head $head|
Out-File "$DB_asukoht\$failinimi" -Encoding utf8     
}

#endregion


#Clear-Variable data